package regexp;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Map;

import automaton.NotDeterministicAutomaton;
import automaton.State;
import automaton.Transition;
import automaton.TransitionImpl;
import automaton.UnknownInitialStateException;

public class AutomatonBuilder {

	private static final Operator OR = new Operator() {
		...
	};

	private static final Operator DOT = new Operator() {
		...
	};

	private static final Operator ITER = new Operator() {
		...
	};

	private static final Operator[] ops = { DOT, OR, ITER };

	private static final Map<String, Operator> operators = new HashMap<String, Operator>();

	static {
		for (Operator op : ops)
			operators.put(op.symbol(), op);
	}

	public static NotDeterministicAutomaton<String> createAutomaton(
			String expression) throws SyntaxErrorException,
			UnknownInitialStateException {
		Iterator<String> its = Arrays.asList(expression.split("\\s"))
				.iterator();
		AutomatonData ad = evaluate(its);
		if (its.hasNext())
			throw new SyntaxErrorException(" : " + its.next());
		for (StateImpl s : ad.initialStates) {
			s.setInitial();
		}
		for (StateImpl s : ad.terminalStates) {
			s.setTerminal();
		}
		return new NotDeterministicAutomaton<String>(ad.transitions
				.toArray(new Transition[ad.transitions.size()]), "");
	}

	private static AutomatonData evaluate(Iterator<String> it)
			throws SyntaxErrorException {
		...
	}

}
